<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRouter } from 'vue-router'
import { MemberProfile } from '../models/member_profile.entity'
import { AxiosHelper } from '../helpers/axios'
import { useAppStore } from '../stores/AppStore'
import { useMemberStore } from '../stores/MemberStore'
import Consts from '../Consts'

// using
const { t } = useI18n({
	messages: {
		en: {
			email: `Email`,
			password: `Password`,
			remember: `Remember Sign-in`,
			forgotPassword: `Forgot password?`,
			ok: `Sign In`,
			signUp: `Sign Up`,
			signInGoogle: `Sign-in to Google`,
			signInLine: `Sign-in to LINE`,
			signInFacebook: `Sign-in to Facebook`,
		},
		th: {
			email: `อีเมล`,
			password: `รหัสผ่าน`,
			remember: `จำรหัสผ่าน`,
			forgotPassword: `ลืมรหัสผ่าน?`,
			ok: `เข้าสู่ระบบ`,
			signUp: `สมัครสมาชิก`,
			signInGoogle: `เข้าสู่ระบบโดย Google`,
			signInLine: `เข้าสู่ระบบโดย LINE`,
			signInFacebook: `เข้าสู่ระบบโดย Facebook`,
		},
	},
})
const router = useRouter()
const appStore = useAppStore()
const memberStore = useMemberStore()

// states
const email = ref(localStorage.getItem('email') || "")
const password = ref(localStorage.getItem('password') || "",)
const remember = ref(localStorage.getItem('remember') ? true : false)

async function onSubmit() {
	// calls REST
	const result = await appStore.waitBoxAsync(async () =>
		await memberStore.client.call(`member/authen/signin`, {
			method: 'PUT',
			//headers: memberStore.defaultHeaders(),
			data: {
				signIn: {
					mail: email.value.trim(),
					password: password.value,
				},
			},
		})
	)
	if (appStore.handleRestResultUi(result))
		return

	// success, retrieves REST data
	memberStore.setProfileState(new MemberProfile(result.json.profile), result.json.token)
	console.log(`member sign-in:`, memberStore.profile)

	// remembers sign-in data?
	if (remember.value) {
		localStorage.setItem('email', email.value.trim())
		localStorage.setItem('password', password.value)
		localStorage.setItem('remember', '1')
	}
	else {
		localStorage.removeItem('email')
		localStorage.removeItem('password')
		localStorage.removeItem('remember')
	}
}

async function onExternalSignIn(url: string) {
	window.location.href = url
}
</script>


<style scoped></style>


<template>
	<form id="signInForm" @submit.prevent="onSubmit">
		<!-- email -->
		<div>
			<label for="email">{{ t('email') }}</label>
			<input id="email" type="email" :placeholder="t('email')" required v-model="email" />
		</div>

		<!-- password -->
		<div>
			<label for="password">{{ t('password') }}</label>
			<input id="password" type="password" :placeholder="t('password')" required minlength="4" maxlength="20"
				v-model="password" />
		</div>

		<!-- remember -->
		<div>
			<input id="remember" type="checkbox" style="margin-right: 0.5rem" v-model="remember" />
			<label for="remember">{{ t('remember') }}</label>
		</div>

		<div>
			<button type="submit">{{ t('ok') }}</button>
			<button type="button" @click.prevent="router.push({ name: 'forgotPass' })">{{ t('forgotPassword')
				}}</button>
			<button type="button" @click.prevent="router.push({ name: 'signup' })">{{ t('signUp') }}</button>

			<button type="button" @click.prevent="(e: Event) => onExternalSignIn(Consts.googleSignIn())">{{
				t('signInGoogle')
			}}</button>
			<button type="button" @click.prevent="(e: Event) => onExternalSignIn(Consts.lineSignIn())">{{
				t('signInLine')
			}}</button>
		</div>
	</form>
</template>
